package org.radargun;

import org.radargun.state.MasterState;

/**
 * A master stage is a stage that only gets executed on the master. E.g. report generation is suitable for being a
 * master stage, as it is only the master having access to all the reports generated by the nodes.
 *
 * @author Mircea.Markus@jboss.com
 */
public interface MasterStage extends Stage {

   void init(MasterState masterState);

   boolean execute() throws Exception;
}
